(defun CNT-LINES (hfn / nh) ;HoldFileName
 (setq nh (open hfn "r") cnt 0)
 (while (read-line nh)(setq cnt (1+ cnt))) 
 (close nh)) 

(defun DO-COM (pn ext cn com / cnt len dosext file-too hdg) ;PathName, extension,CatalogName,command
 (repeat 25(print))(textscr) 
 (princ (strcat "\nPlease wait...building catalog " ext)) 
 (print) 
 (setq len 1 cnt 0 hdg (strcat (chr 32) ext (chr 32))
       dosext (strcat (chr 32) (substr ext 3 3) (chr 32))
       file-too "")
 (write-dir (strcat pn ext) cn dosext)
 (setq peek (open cn "r"))
 (if (/= (read-line peek) nil)
  (progn
   (apply '(lambda (txt-loc) (repeat 50
                               (grtext txt-loc "        ")
                               (setq txt-loc (1+ txt-loc)))) '(0))
   (pop-scrn hdg "********" cn 2 "mc")
   (if (/= cancel? "YES")
    (progn
     (repeat 8 
       (if (/= (substr hldfile len 1) (chr 32))
        (setq file-too (strcat file-too (substr hldfile len 1))
              len (1+ len))))
     (if (= com "LOAD")
      (setq loadflag "YES" runfile (strcat pn file-too ".LSP"))
      (command com (strcat pn file-too (substr ext 2)))
     )))) 
  (progn
   (graphscr)(print) 
   (princ "\n\t\t< Illegal path or no Matching files >")
   (print) 
   (getstring "\npress any key to continue..."))))
 
(defun PICK-FILE (/ pt1)
 (repeat 5 (print)) 
 (prompt "\nSelect file : ")
 (setq pt1 (grread) sel-loc (car pt1) file-sel (cadr pt1))
 (cond
  ((/= sel-loc 4) (pick-file))
  ((and (= cur-pg num-pgs)(= file-sel 19))
   (setq more? "NO" cancel? "YES"))
  ((and (= cur-pg num-pgs)
    (or (> file-sel (1+ ch-lst)) (= file-sel 0) (= file-sel 1)))
   (pick-file))
  ((or (= file-sel 0) (= file-sel 1) (> file-sel 19)) (pick-file))
  ((and (= sel-loc 4)(= file-sel 19))(setq more? "YES"))
  ((and (= sel-loc 4)(/= file-sel 19))(setq more? "NO"))))

(defun pop-scrn (hdg l2 fn sn nh / ctr cnt txt-loc sn nh) ; HeaDinG, Line2, filename, StartNumber, NameHolder
 (setq cnt 0 txt-loc 0)
 (cnt-lines fn)
 (repeat 19(grtext txt-loc "        ")(setq txt-loc (1+ txt-loc)))
 (if (> cnt 17)
  (progn
   (grtext txt-loc "* Next *")
   (setq txt-loc (1+ txt-loc))))
 (repeat 10 
   (grtext txt-loc "        ")
   (setq txt-loc (1+ txt-loc)))
 (grtext 0 hdg)
 (grtext 1 l2)
 (setq nh (open fn "r") ch-lst 0 ctr sn
       num-pgs (fix (+ 1 (/ cnt 17.00)))
       txt-loc sn old-pgs 0 cur-pg 1
       ch-rem (1- cnt) cur-mem 1
       more? "yes" cancel? "NO" hldfile nil)
 (if (> ch-rem 17)
  (setq ch-pg 17)
  (setq ch-lst ch-pg
        ch-pg ch-rem))
 (while (/= more? "NO")
   (print hldfile)
   (if (= cur-pg num-pgs)
    (progn
     (setq ch-lst ch-rem txt-loc sn)
     (repeat 17 
       (grtext txt-loc "        ")
       (setq txt-loc (1+ txt-loc)))
     (grtext txt-loc " Return ")))
   (setq txt-loc sn)
   (repeat ch-pg
     (grtext txt-loc (read-line nh))
     (setq txt-loc (1+ txt-loc)
           ch-rem (1- ch-rem)
           cur-mem (1+ cur-mem))
    (if (> ch-rem 17)(setq ch-pg 17)(setq ch-pg ch-rem)))
   (pick-file)
   (setq old-pgs (1+ old-pgs) cur-pg (1+ cur-pg)))
 (close nh) 
 (if (/= cancel? "YES")
  (progn
   (setq nh (open fn "r"))
   (repeat (+ (* 17 (* (1- old-pgs))) (- file-sel 2))
    (print (read-line nh))) 
   (setq hldfile (read-line nh))
   (close nh) 
   (print hldfile))))
 
(defun SEL-OPT (ig ps df ol / hold)  ;InitGet, PromptString,DeFault, OptionLine
 (initget ig)
 (repeat 24 (print)) 
 (princ ps)(print)(princ "\n")
 (setq option df hold option
       option (getkword (strcat ol option ">: ")))
 (if (null option)(setq option hold))
 (repeat 5 (print)) 
 (prin1))
 
(defun WRITE-DIR (pn cat-file ext / nh cur-line cnt) ;Path Name, catalogfile, extension
 (command "DIR" (strcat pn ">hold.DIR"))
 (cnt-lines "hold.DIR")
 (setq nh (open "hold.DIR" "r") cat-file (open cat-file "w"))
 (repeat (1- cnt)
   (setq cur-line (read-line nh))
   (if (= (substr cur-line 9 5) (strcase ext))
    (write-line (substr cur-line 1 12) cat-file)))
 (close nh)(close cat-file)(prin1))

(defun C:USEDOS ()
 (graphscr)(repeat 5 (print)) 
 (setq loadflag "NO" def-path (getvar "DWGPREFIX")
       pathname (getstring (strcat "\npath to search <" def-path "> : ")))
 (if (= pathname "")(setq pathname def-path))
 (if (/= (substr pathname (strlen pathname)) "\\")
  (setq pathname (strcat pathname "\\")))
 (sel-opt "Block Lisp Slide X" "\nselect file TYPE... " "Lisp" "Block/Lisp/Slide/eXit<")
 (cond
  ((= option "Block") (do-com pathname "*.dwg" "BLOCKS.cat" "INSERT"))
  ((= option "Lisp")
    (sel-opt "Browse Edit Load" "\nselect TASK... " "Load" "Browse/Edit/Load<")
    (cond
     ((= option "Browse") (do-com pathname "*.lsp" "LISP.cat" "TYPE"))
     ((= option "Edit") (do-com pathname "*.lsp" "LISP.cat" "Edit"))
     ((= option "Load") (do-com pathname "*.lsp" "LISP.cat" "LOAD"))))
  ((= option "Slide") (do-com pathname "*.sld" "SLIDE.cat" "VSLIDE")) )
 (grtext)(repeat 5 (print)) 
 (if (= loadflag "YES")
  (progn
   (princ (strcat "\nLoading <" runfile ">\n"))
   (load runfile))
  (prin1)))

