;flag values: 0=singlelines, write to fil 1=multilines
;             2=read only (added 2-12-92)
;Form   (browse flag fname)


(defun PLACETXT (txtline just)
(cond ((and (= just "L")(= tsize nil))
       (command ".Text" P1 0 txtline))
      ((and (/= just "L")(= tsize nil))
        (command ".Text" just P1 0 txtline))
      ((and (/= just "L")(= (type tsize) 'real))
        (command ".Text" just P1 tsize 0 txtline))
      ((and (= just "L")(= (type tsize) 'real))
        (command ".Text" P1 tsize 0 txtline)))
(setq p1 (List (Car p1) (- (Cadr p1) lspace)))
)


(Defun SM-IMPORT (snumb enumb efnam flag)
(if (/= (type tsize) 'real)
    (setq tsize (getvar "TEXTSIZE")))
(if (/= (type lspace) 'real)
    (setq lspace (* 1.5 (getvar "TEXTSIZE"))))
(setq just "L" cntr 0
      fptr1 (Open efnam "r"))
(repeat (- snumb 1) (read-line fptr1))
(setq txtline (Read-line fptr1))
(if (or (= flag "S")(= flag "B"))(progn
    (setq ctxtsty (tblsearch "style" (getvar "TEXTSTYLE")))
    (if (= (cdr (assoc 40 ctxtsty)) 0)
        (progn (initget 6)
        (setq x (getreal (strcat "\nEnter the .Text height <"
                         (rtos tsize 2 3) ">: ")))
        (If (/= x nil) (setq tsize x)));progn
            (setq tsize nil)
    );if
    (if (> enumb snumb) (progn
        (initget 2)
        (setq x (getreal (strcat "\nEnter the line spacing <"
                          (rtos lspace 2 3) ">: ")))
        (If (/= x nil) (setq lspace x))
    ));progn/if
    (graphscr)
    (initget 1 "C M R")
    (setq x (getpoint "\nStart point or Center/Middle/Right: "))
    (cond ((= (type x) 'List) (setq p1 x) (setq smimp-just "L"))
          ((= x "C") (setq just x)
           (initget 1)
           (setq p1 (getpoint "\nCenter point: ")))
          ((= x "M") (setq just x)
           (initget 1)
           (setq p1 (getpoint "\nMiddle point: ")))
          ((= x "R") (setq just x)
           (initget 1)
           (setq p1 (getpoint "\nEnd point: ")))
     );conditional
     ));progn/if
    (if (or (= flag "F")(= flag "B"))
        (setq fptr2 (open "c:/mlisp/brwstemp.txt" "w")))

;    In line above C:\MLISP is our directory.
;    Change to  meet your needs.

     (while (and (<= cntr (- enumb snumb)) (/= txtline nil))
        (if (or (= flag "S")(= flag "B"))
            (placetxt txtline just))
        (if (or (= flag "F")(= flag "B"))
            (write-line txtline fptr2))
        (setq cntr (+ 1 cntr)
              txtline (read-line fptr1))
      );while
    (if (or (= flag "F")(= flag "B"))(close fptr2))
    (if (or (= flag "S")(= flag "B"))(close fptr1))
(princ))

;flag values: 0=singlelines, write to file only
;             1=multilines, write to file and screen
;             2=read only

(defun BROWSE ( flag fname)
(setq fptr (open fname "r")
      indx 1
      line_numb nil)
(if fptr (progn
   (textscr)
(if (/= flag 2) (prompt (strcat "\nBrowsing " fname)))
   (setq txtline (read-line fptr))

(if (/= flag 2) (progn  (terpri)(princ indx)(princ "\t")(princ txtline))
    (progn (terpri)(princ txtline)))
   (while txtline
      (setq indx (+ 1 indx)
            txtline (read-line fptr))
      (if txtline (progn
          (if (/= flag 2) (progn
              (terpri)(princ indx)(princ "\t")(princ txtline))
              (progn (terpri)(princ txtline)))))
      (if (= (rem indx 23) 0)(progn
          (if (/= flag 2) (prompt (strcat "\n" fname " - Paused...")))
          (initget "S")
          (setq kw9 (getkword "\nStop/<Enter=continue>: "))
          (if (= kw9 "S")(setq txtline nil))))
   );while
   (close fptr)
   (cond ((= flag 1)
          (initget "F S B E")
          (setq kw3 (getkword "\nWrite line(s) to File/Screen/Both/Exit <E>: "))
          (if (and (/= kw3 "E")(/= kw3 nil)(/= (type line_numb) 'int))
              (progn
              (setq x (getint "\nStarting line number to write <1>: "))
              (if x (setq sline_numb x)(setq sline_numb 1))

              (setq x (getint (strcat "\nEnding line number to write <"
                                        (itoa sline_numb) ">: ")))
              (If x (setq eline_numb x)(setq eline_numb sline_numb))
           ));if/progn
            (if (or (= kw3 "F")(= kw3 "B")(= kw3 "S"))
                (sm-import sline_numb eline_numb fname kw3)))
           ((= flag 0)
               (initget 1)
               (setq sline_numb (getint "\nEnter line number: "))
               (sm-import sline_numb sline_numb fname "F"))
         );conditional
       );progn
(prompt "\nFile not found"));if
(princ))

